# -*- coding: utf-8 -*-
import subprocess

from optparse import make_option

from django.core.management.base import BaseCommand, CommandError
from django.contrib.auth.models import User as Django_User

PWLENGTH = 10


class Command(BaseCommand):
    help = "Create a User."
    args = "<username> <email> [<result.txt>]"

    def add_arguments(self, parser):
        parser.add_argument("--username",
                            dest="username",
                            help="Define new users name"),
        parser.add_argument("--email",
                            dest="email",
                            help="Define new users email"),
        parser.add_argument("--out",
                            dest="out",
                            help="Define output file",
                            default="result.txt"),
        parser.add_argument("--password", dest="password",
                            help="Define password for new user",
                            default=None),
        parser.add_argument("--pwlength", dest="pwlength",
                            help="Length of the password",
                            default=str(PWLENGTH)),
        parser.add_argument("--firstname", dest="firstname",
                            help="Firstname of the new user",
                            default=None),
        parser.add_argument("--lastname", dest="lastname",
                            help="Lastname of the new user",
                            default=None),

    def handle(self, *args, **options):
        username = options.get("username")

        if Django_User.objects.filter(username=username).count():
            raise CommandError("Username already exists")

        email = options.get("email")
        password = options.get("password", None)
        pwlength = options.get("pwlength", str(PWLENGTH))

        if not password:
            # head -c $Anzahl_Bytes /dev/urandom | base64 | tr -d '\n='
            process1 = subprocess.Popen(["head", "-c", pwlength,
                                         "/dev/urandom"],
                                        stdout=subprocess.PIPE)
            process2 = subprocess.Popen(["base64"],
                                        stdin=process1.stdout,
                                        stdout=subprocess.PIPE)
            process3 = subprocess.Popen(["tr", "-d", "'\n='"],
                                        stdin=process2.stdout,
                                        stdout=subprocess.PIPE)
            password, _ = process3.communicate()

        password = password.strip()

        user = Django_User.objects.create_user(username, email, password)

        lastname = options.get("lastname", None)
        if lastname:
            user.last_name = lastname

        firstname = options.get("firstname", None)
        if firstname:
            user.first_name = firstname

        user.save()

        if len(args) == 3:
            result = args[3]
        else:
            result = "result.txt"

        with open(result, "a") as passwordfile:
            passwordfile.write("%s\t%s\n" % (username, password))

        print u"Created user '%s' \n" % username,
